﻿using System;

namespace TemplateMethodHotDrink
{
    public abstract class AbstractHotDrink
    {

        // template method
        public void Prepare()
        {
            BoilWater();
            Brew();
            PourInCup();
            AddExtras(); // sugar + milk ect.
        }

        private void BoilWater() { Console.WriteLine("Boil water"); }

        protected abstract void Brew();

        private void PourInCup() { Console.WriteLine("Pour into cup"); }

        // hook method
        protected virtual void AddExtras() { 
            // empty, but sub-classes can override to do something
        }
    }
}
